﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CharaEdit40
{
    public partial class DlgCanvasSize : Form
    {
        public static Size sizeCanvas;      // 現在のキャンバスサイズ
        private bool bNumeric = false;

        // -------------------------------------------------------------
        // コンストラクタ
        // -------------------------------------------------------------
        public DlgCanvasSize()
        {
            InitializeComponent();
        }

        // -------------------------------------------------------------
        // ダイアログがロードされる
        // -------------------------------------------------------------
        private void DlgCanvasSize_Load(object sender, EventArgs e)
        {
            FormBorderStyle = FormBorderStyle.FixedSingle;
            Size = new Size(274, 270);
            MaximumSize = Size;
            MinimumSize = Size;
            numUpDnWidth.Text = tbNowWidth.Text = sizeCanvas.Width.ToString();
            numUpDnHeight.Text = tbNowHeight.Text = sizeCanvas.Height.ToString();

            int size = sizeCanvas.Width * sizeCanvas.Height * 2;
            string num = size >= 1024
                ? (size / 1024f).ToString("######.#") + "KB"
                : size.ToString("######") + "B";
            grpNow.Text = "現在のファイルサイズ: " + num;

            Point pos = MainForm.form.Location;
            pos.X += (MainForm.form.Size.Width - Width) / 2;
            pos.Y += (MainForm.form.Size.Height - Height) / 2;
            Location = pos;
        }

        // -------------------------------------------------------------
        // 値が変更された
        // -------------------------------------------------------------
        private void numUpDn_ValueChanged(object sender, EventArgs e)
        {
            if (bNumeric) return;
            bNumeric = true;
            NumericUpDown numUD = (NumericUpDown)sender;
            if (checkBoxAspectRatio.Checked)
            {
                try
                {
                    if (numUD.Name.IndexOf("Width") >= 0)
                    {
                        // 幅が変更されたので高さを調整する
                        float aspectRatio = sizeCanvas.Height / (float)sizeCanvas.Width;
                        numUpDnHeight.Value = (int)(aspectRatio * (int)numUpDnWidth.Value);
                    }
                    else
                    {
                        // 高さが変更された
                        float aspectRatio = sizeCanvas.Width / (float)sizeCanvas.Height;
                        numUpDnWidth.Value = (int)(aspectRatio * (int)numUpDnHeight.Value);
                    }
                }
                catch { }
            }
            int size = (int)numUpDnWidth.Value * (int)numUpDnHeight.Value * 2;
            string num = size >= 1024
                ? (size / 1024f).ToString("######.#") + "KB"
                : size.ToString("######") + "B";
            grpNew.Text = "現在のファイルサイズ: " + num;
            bNumeric = false;
        }

        // -------------------------------------------------------------
        // OKボタンが押された
        // -------------------------------------------------------------
        private void btnOK_Click(object sender, EventArgs e)
        {
            sizeCanvas.Width = (int)numUpDnWidth.Value;
            sizeCanvas.Height = (int)numUpDnHeight.Value;
            DialogResult = DialogResult.OK;
            Close();
        }

        // -------------------------------------------------------------
        // キャンセルボタンが押された
        // -------------------------------------------------------------
        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }
    }
}
