﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static CharaEdit40.Define;

namespace CharaEdit40
{
    public partial class DlgExpBinary : Form
    {
        public int sizeData = 0;

        // -------------------------------------------------------------
        // コンストラクタ
        // -------------------------------------------------------------
        public DlgExpBinary()
        {
            InitializeComponent();
        }

        // -------------------------------------------------------------
        // ダイアログがロードされる
        // -------------------------------------------------------------
        private void DlgExpBinary_Load(object sender, EventArgs e)
        {
            tbSize.Text = sizeData.ToString();

            FormBorderStyle = FormBorderStyle.FixedSingle;
            Size = new Size(413, 221);
            MaximumSize = Size;
            MinimumSize = Size;

            Point pos = MainForm.form.Location;
            pos.X += (MainForm.form.Size.Width - Width) / 2;
            pos.Y += (MainForm.form.Size.Height - Height) / 2;
            Location = pos;

            cbOutputFormat.SelectedIndex = 0;
            numUDTopAddress.Focus();
        }

        // -------------------------------------------------------------
        // 開始アドレスが変更される
        // -------------------------------------------------------------
        private void numUDTopAddress_ValueChanged(object sender, EventArgs e)
        {
            if (numUDTopAddress.Value + sizeData > 0xFFFF)
            {
                numUDTopAddress.Value = 0x10000 - sizeData;
                return;
            }
            if (numUDTopAddress.Value + sizeData - 1 != numUDEndAddress.Value)
            {
                numUDEndAddress.Value = numUDTopAddress.Value + sizeData - 1;
            }
        }

        // -------------------------------------------------------------
        // 終了アドレスが変更される
        // -------------------------------------------------------------
        private void numUDEndAddress_ValueChanged(object sender, EventArgs e)
        {
            if (numUDEndAddress.Value - sizeData + 1 < 0)
            {
                numUDEndAddress.Value = sizeData - 1;
                return;
            }
            if (numUDEndAddress.Value - sizeData + 1 != numUDTopAddress.Value)
            {
                numUDTopAddress.Value = numUDEndAddress.Value - sizeData + 1;
            }
        }

        // -------------------------------------------------------------
        // 出力形式が変更された
        // -------------------------------------------------------------
        private void cbOutputFormat_SelectedIndexChanged(object sender, EventArgs e)
        {
            numUDTopAddress.Enabled = numUDEndAddress.Enabled = cbOutputFormat.SelectedIndex != 0;
            switch (cbOutputFormat.SelectedIndex)
            {
                case 2:  Path.ChangeExtension(lbPath.Text, "t88"); break;
                case 3:  Path.ChangeExtension(lbPath.Text, "cmt"); break;
                default: Path.ChangeExtension(lbPath.Text, "bin"); break;
            }

        }

        // -------------------------------------------------------------
        // 出力するボタンが押された
        // -------------------------------------------------------------
        private void btnOK_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
            Close();
        }

        // -------------------------------------------------------------
        // キャンセルボタンが押された
        // -------------------------------------------------------------
        private void btnCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }
    }
}
