﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CharaEdit40
{
    class J80cmt
    {
        private byte[] _datas;              // 出力データ
        public J80cmt(byte[] datas, UInt16 start)
        {
            const byte gap = (byte)0x3A;
            List<byte> lsBinary = new List<byte>(datas);
            using (MemoryStream ms = new MemoryStream())
            using (BinaryWriter bw = new BinaryWriter(ms))
            {
                // ヘッダ出力
                bw.Write(gap);
                bw.Write((byte)(start / 256));
                bw.Write((byte)(start % 256));
                bw.Write(Neg((byte)(start / 256 + start % 256)));

                // データブロック出力
                int ptr = 0;
                int end = lsBinary.Count();
                do
                {
                    List<byte> blocks = lsBinary.GetRange(ptr, end - ptr >= 255 ? 255 : end - ptr);
                    ptr += blocks.Count();
                    bw.Write(gap);
                    byte sum = (byte)blocks.Count();
                    bw.Write(sum);
                    foreach (byte b in blocks)
                    {
                        sum += b;
                        bw.Write(b);
                    }
                    bw.Write(Neg(sum));
                }
                while (ptr < end);

                // 終端処理
                bw.Write(gap);
                bw.Write((ushort)0);

                _datas = ms.ToArray();
            }
        }
        public byte[] GetBinary() { return _datas; }

        static private byte Neg(byte b)
        {
            return (byte)((~b + 1) % 256);
        }
    }
}
